' ViewPath.VBS V1.03 (C) yoshioka.teruo@nifty.com 2005-12-19
' ViewPath.VBS opens file or folder in recycle bin.
' Usage: ViewPath.VBS

Option Explicit
Dim Shell
Dim Path
Dim fso
Dim wShell
Dim ans
Dim Folder
Dim File
Dim SubFolder
Dim ie
Dim FolderItem
Dim NewFolder

Set Shell=CreateObject("Shell.Application")
Path=Shell.Windows().Item().Document.FocusedItem.Path
Set fso=CreateObject("Scripting.FileSystemObject")
Set wShell=CreateObject("WScript.Shell")
If fso.FileExists(Path) Then
  ans=MsgBox(Path,vbYesNoCancel,"View Path with [Yes]Explorer [No]NotePad [Cancel]Clipboard ?")
  If ans=vbYes Then
    Set File=fso.GetFile(Path)
    Set Folder=File.ParentFolder
    If Folder.SubFolders.Count=0 Then
      NewFolder=fso.GetTempName()
      Folder.SubFolders.Add NewFolder
    End If
    For Each SubFolder In Folder.SubFolders
      Exit For
    Next
    wShell.Run """"&SubFolder.Path&""""
    Do
      Set ie=Shell.Windows().Item()
      If ie Is Nothing Then
      ElseIf ie.Busy Then
      ElseIf ie.ReadyState<>4 Then
      ElseIf InStr(TypeName(ie.Document),"IShellFolderView")=0 Then
      ElseIf ie.Document.Folder.Items().Item().Path=SubFolder.Path Then
        Exit Do
      End If
      WScript.Sleep 100
    Loop
    wShell.SendKeys "{BS}"
    Do While ie.Busy Or ie.ReadyState<>4
      WScript.Sleep 100
    Loop
    If Not IsEmpty(NewFolder) Then Folder.SubFolders.Item(CStr(NewFolder)).Delete
    Set FolderItem=ie.Document.Folder.Items.Item(File.Name)
    ie.Document.SelectItem FolderItem,1+4+8+16
  ElseIf ans=vbNo Then
    wShell.Run "NotePad.EXE " & Path
  ElseIf ans=vbCancel Then
    PutClipByMsIE Path
  End If
ElseIf fso.FolderExists(Path) Then
  ans=MsgBox(Path,vbYesNoCancel,"View Path with [Yes]Explorer [No]Command Prompt [Cancel]Clipboard ?")
  If ans=vbYes Then
      wShell.Run """"&Path&""""
  ElseIf ans=vbNo Then
    If InStr(WScript.FullName,"32") Then
      wShell.Run "CMD.EXE /K CD /D " & Path
    ElseIf CDbl(WScript.Version)>5.5 Then
      wShell.CurrentDirectory=Path
      wShell.Run "COMMAND.COM"
    ElseIf UCase(Left(Path,1))=UCase(Left(fso.GetAbsolutePathName(""),1)) Then
      wShell.Run "COMMAND.COM /K CD " & Path
    Else
      wShell.Run "COMMAND.COM /K " & Left(Path,2) & " | CD " & Path
    End If
  ElseIf ans=vbCancel Then
    PutClipByMsIE Path
  End If
End If

Function PutClipByMsIE(Text)
Const OLECMDID_COPY=12
Const OLECMDID_SELECTALL=17 '(&H11)
Const OLECMDEXECOPT_DODEFAULT=0
Dim ie
Set ie=CreateObject("InternetExplorer.Application")
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.body.innerText=Text
ie.ExecWB OLECMDID_SELECTALL,OLECMDEXECOPT_DODEFAULT
ie.ExecWB OLECMDID_COPY,OLECMDEXECOPT_DODEFAULT
ie.Quit 
Set ie=Nothing
End Function
